#!/bin/bash
# 变量
# 
# home
# user
# passwd
# modelpath
# modelname
# gpucnt
# port
#
# 开始要检查安装nvidia驱动

sudo apt install git-lfs
sudo rm -rf {{home}}
sudo mkdir {{home}}
sudo chown -R $(id -un):$(id -gn) {{home}}
sudo apt -y install python3-venv
mkdir {{home}}/.pip
cat <<EOF> {{home}}/.pip/pip.conf
[global]
index-url = https://pypi.tuna.tsinghua.edu.cn/simple
[install]
trusted-host = https://pypi.tuna.tsinghua.edu.cn
EOF
cat <<EOF>{{home}}/run.sh
#!/bin/bash

{{home}}/py3/bin/python -m vllm.entrypoints.openai.api_server --model {{modelpath}} --served-model-name {{modelname}} --gpu-memory-utilization 0.9 --max_model_len {{max_model_len or 4096}} --tensor-parallel-size {{gpucnt}} --port {{port or 8001}}
EOF
chmod +x {{home}}/run.sh
cat <<EOF>{{home}}/{{user}}.service
[Unit]
Wants=systemd-networkd.service

[Service]
Type=forking
ExecStart=su - {{user}} -c "{{home}}/run.sh"
ExecStop=su - {{user}} "killname vllm"
[Install]
WantedBy=multi-user.target
EOF
sudo mv {{home}}/{{user}}.service /etc/systemd/system
python3 -m venv {{home}}/py3
{{home}}/py3/bin/pip install torch==2.4.0+cu124 torchaudio==2.4.0+cu124 --extra-index-url https://download.pytorch.org/whl/cu124
{{home}}/py3/bin/pip install vllm==0.7.3
sudo deluser {{user}}
sudo delgroup {{user}}
sudo groupadd {{user}}
sudo useradd -m -g {{user}} -s /usr/bin/bash -d {{home}} {{user}}
echo "{{user}}:{{passwd}}" | sudo chpasswd
sudo chown -R {{user}}:{{user}} {{home}}
sudo systemctl enable {{user}}.service
sudo systemctl start {{user}}.service

exit 0
